***** Flag Browser ***********************************************************
******************************************************************************
* TITLE		: Flag Browser - displays the 64 system flags
*
* Author	: Richard Steventon
* Description	: shows flags 1 to 64 with a scroll bar for flags
*		  [NXT] key toggles between User and System
*		  [+/-] key toggles the flag (indicated by a "tick" mark)
*		  [ENTER] save flags, [ATTN] exits without saving
*		  ! USES Jazz.lib SMALL FONT !
* 
* !!!!!!!!!!!!!!!! FOR RPLCOMP.EXE due to REL(4) and NIBASC !!!!!!!!!!!!!!!!!!
*
* ENTRY		: -
* EXIT		: -
* Error Exit 	: -
*
* History	: written			:  5 September 1994
*		  commented			:  6 September 1994
*		  did GX flags & changed table	: 27 September 1994
*		  add user flags & BEEP fix	:  4 October   1994
*		  add key release check on NXT  :  5 October   1994
*
* USES	: A.A	:
*	  B.A	:
*	  C.A	:
* 	  D.S	: current row of display highlighted
*	  P	: general purpose loop counter
*	  R4[w->f] current delay time
* 	  R4.F	: the current flag at the top of display
* 	  R3	: User flags
*	  R3.WA	: font data begin address (used by WriteLine)
* 	  R2.A	: OffsetTable address
* 	  R1	: system flags
* 	  R0	: used by WriteLine	: string address


* CALLS	: GETPTRLOOP, DisableIntr, EnableIntr
*	: PopASavPtr	: pops STK1 into A.A and does SAVPTR
*	: AINRTN	: does A=IN, RTN (on an even address)
*	: ASLW5		: does ASL  W  five times.... go figure.
*	: D0->Row1	: D1 = beginning of HARDBUFF (sx & gx)
*	: MUL#		: C.A * A.A -> B.A (integer math)
*	: Kbd_OR	: checks whether a key is pressed -> Carry if True
*	: ThisKeyDn?	: checks whether the key specified by the keycode 
*			  in C.B is down -> Carry if True
******************************************************************************


	TITLE	   Flag Browser v 1.2


ASSEMBLE
********** Unsupported Entry Points ******************************************
Kbd_OR		EQU	#00E0B
ThisKeyDn?	EQU	#00C8D
PopASavPtr	EQU	#3251C		* supported but not in entries.o
addrADISP	EQU	#1265A		* base address of Display
clrbusy		EQU	#42359		* turns off the "busy" annun.
WIPEOUT		EQU	#0675C		* clears A.A nibs; D1 = start addr
********** GX specific entry points ******************************************
SystemFlagsGX	EQU	#80843
UserFlagsGX	EQU	(SystemFlagsGX)+16
********** ST FLAGS **********************************************************
sFAST		EQU	0
sClear?		EQU	1
sUSER		EQU	2
sBEEP		EQU	4
******************************************************************************
RPL
::
 RECLAIMDISP TURNMENUOFF 	( set display size to 131 x 64 )
 ROMPTR 3E0 0			( small font from JAZZ v 1.0 library )
 CODE
	GOSBVL	=PopASavPtr	
	A=A+CON	A,10		point past prolog to data
	GOSBVL	=ASLW5
	R2=A			save font data begin address

********* initialize variables ***********************************************
	ST=0	=sFAST		startup in slow mode
	ST=0	=sUSER		startup showing System Flags
	GOSBVL	=getBPOFF	set BEEP flag status

	GOSUB	GetTab		returns with C.A = Addr of Table
	R2=C.F	A		save address of font offset table


* get the system flags
	GOSUB	D1->SysFlags	
	C=DAT1	W		C.A = system flags
	R1=C	W		store them
	D1=D1+	16
	C=DAT1	W		C.A = user flags
	R3=C	W	

* now initialize the flag number at line 1 and timer in R4
startup
	GOSUB	D1->SysFlags	
	?ST=0	=sUSER
	GOYES	startcont
	D1=D1+	16
startcont
	A=0	W		
	A=A+1	A
	R4=A			flag 1

********* now we show the display ********************************************
	D=0	S		initialize number of lines to show
ShowLp	D=D+1	S
	LC(1)	10		
	CSRC	W
	?D>C	S		displayed 10 lines yet ?
	GOYES	finShlp		then finish
	GOSUB	D->scroll	get current line (as a flag) into C.A
	GOSUB	Set?		
	GOC	flgclear	not set....
	GOSUB	D->scroll	get current loop/line counter
	GOSUB	SetRow		show a "tick" mark for set
flgclear
	GOSUB	D->scroll
	A=C	A		A.A = 0000(line number)
	GOSUB	ShowNum		show the flag number
	GOSUB	D->scroll
	A=C	A		A.A = 0000(line number)
	GOSUB	ShowLine	show the String Text about the flag
	GOTO	ShowLp
finShlp
	LC(5)	#11		#1 for D.S and #1 for Invert!
	CSRC	W		setup current scroll bar
	D=C	S
	GOSUB	Invert!		set scroll bar

	GOSBVL	=DisableIntr	
	GOSBVL	=clrbusy

*** Start of main loop ******************************************************
main	GOSUB   delay?		is there a key delay?
	GOSBVL  =Kbd_OR
	GOC     key!		key is being pressed so don't sleep!

	SHUTDN			no keys pressed, so go sleep

key!	GOSUB	UpdateTime
******************************************************************************
****** Main Key definitions **************************************************
******************************************************************************
	LC(2)   #31			key [+]
	GOSUB   keyPressed?
	GONC    key1
	ST=1    =sFAST			set fast mode
key1	LC(2)   #2C			key [-]
	GOSUB   keyPressed?
	GONC    key2
	ST=0    =sFAST			set slow mode
key2	LC(2)   #B			UpCursor
	GOSUB   keyPressed?
	GONC    key3
	GOTO    UpCursor
key3	LC(2)   #11			DnCursor
	GOSUB   keyPressed?
	GONC    key4
	GOTO    DnCursor
key4	LC(2)	#1A			[+/-] = toggle flag
	GOSUB   keyPressed?
	GONC    key7
	GOTO    Toggle
key7	LC(2)	#0C			NXT key
	GOSUB   keyPressed?
	GONC    key8

	?ST=0	=sUSER			system flags displayed?
	GOYES	NXTcnt1
	ST=0	=sUSER			no, set them
	GOTO	NXTcnt2
NXTcnt1	ST=1	=sUSER			yes, set User
NXTcnt2
wt1	GOSBVL  =Kbd_OR
	GOC     wt1			wait till key released
	GOSUB	D->scroll		turn off old scroll bar
	GOSUB	Invert!			set scroll bar
	GOSBVL	=D0->Row1		
	AD0EX				
	AD1EX				
	LC(5)	34*64			clear display
	GOSBVL	=WIPEOUT
	GOTO	startup			start up with new flag type

key8	LC(2)   #19			[ENTER] = exit and SAVE FLAGS !!!
	GOSUB   keyPressed?
	GOC     save
	GOSBVL  =AINRTN
	?ABIT=1 15			[ATTN] = exit and DON'T SAVE FLAGS !!!
	GOYES   exit
	GOTO    main			start main loop again

save	GOSUB	D1->SysFlags		get flag address
	A=R1				get flags
	DAT1=A	W			save them and fall though into exit
	A=R3
	D1=D1+	16
	DAT1=A	W

* we now wait until a key is no longer pressed... so the user is not still
* pressing the key when we exit.....
exit	GOSBVL  =Kbd_OR
	GOC     exit			key still pressed?
	GOSBVL  =AllowIntr		turn keyboard back on...
	GOVLNG  =GETPTRLOOP		restore regs & return to RPL

**** Main Key Definitions ****************************************************
*
******************************************************************************
UpCursor
	GOSUB	D->scroll	current line highlighted
	C=C-1	A		initialize it
	?C=0	A		scroll bar at top?
	GOYES	copyup		gotta copy the display up.... ---------- 
	D=C	A		D.A = new line to be highlighted	|
	C=C+1	A		C.A = line to remove highlight bar from |
	GOSUB	Invert!		remove bar				|
	C=D	A							|
	GOSUB	Invert!		set bar					|
	D=D-1	S		set new value for flag at top		|
	GOTO	main							|
*									|
copyup	C=R4			get current flag displayed at top   <-- '
	LA(5)	1		
	?C#A	A		are we at the top?
	GOYES	upcurnxt
	GOSUB	BadKey		then beep
	GOTO	main		and return to main
upcurnxt
	LC(5)	1
	GOSUB	Invert!		kill the highlight bar

* now we copy the display "down"
	GOSBVL	=D0->Row1
	AD0EX
	LC(5)	34*56
	A=A+C	A
	D0=A
	LC(5)	34*6
	A=A+C	A
	D1=A
	LC(5)	34*54
	GOSBVL	=MOVEUP		from D0 to D1, C.A nibbs

* and insert the new line at the top
	C=R4.F	A
	C=C-1	A
	R4=C.F	A
	LA(5)	1
	GOSUB	ShowNum		show the flag number
	C=R4.F	A
	LA(5)	1
	GOSUB	ShowLine	show the string
	C=R4.F	A
	GOSUB	Set?
	GOC	upcl		if flag clear
	LA(5)	1
	GOSUB	showclear
	LC(5)	1
	GOSUB	SetRow		otherwise show it set
	GOTO	upnxt
upcl	LA(5)	1
	GOSUB	showclear

upnxt	LC(5)	1		invert line 1 again
	GOSUB	Invert!
	GOTO	main

******************************************************************************
** Key definition for Down Arrow
******************************************************************************
DnCursor
	GOSUB	D->scroll
	LA(5)	10
	?C=A	A		highlight bar at the bottom?
	GOYES	copydn		no, ok... just move highlight bar down 1 line
	D=C	A
	GOSUB	Invert!		kill old bar
	C=D	A
	C=C+1	A
	GOSUB	Invert!		set new bar 1 line down
	D=D+1	S
	GOTO	main		return to main loop

copydn	C=R4.F	A
	LA(5)	64-9		last flag **shown at top**
	?C#A	A		there yet?
	GOYES	dncurnxt
	GOSUB	BadKey		then beep
	GOTO	main		and return to main

* highlight bar is at bottom of display -> copy display up and show next line
dncurnxt
	LC(5)	10
	GOSUB	Invert!		kill highlight bar

* now we must copy the display "up"
	GOSBVL	=D0->Row1
	AD0EX
	LC(5)	34*2
	A=A+C	A
	D1=A
	LC(5)	34*6
	A=A+C	A	
	D0=A	
	LC(5)	34*54
	GOSBVL	=MOVEDOWN

* ok, now show the new line
	C=R4.F	A		get top of display flag
	C=C+1	A		
	R4=C.F	A			write back
	LA(5)	9
	C=C+A	A
	LA(5)	10		calc flag number at bottom of display
	GOSUB	ShowNum		show string
	C=R4.F	A		write back
	LA(5)	9
	C=C+A	A
	LA(5)	10		calc flag number at bottom of display
	GOSUB	ShowLine	show string

	C=R4.F	A
	LA(5)	9
	C=C+A	A
	GOSUB	Set?		new flag set?
	GOC	dncl		set
	LC(5)	10		
	GOSUB	showclear
	LC(5)	10
	GOSUB	SetRow
	GOTO	dnnxt
dncl	LA(5)	10
	GOSUB	showclear
dnnxt	LC(5)	10		and reset the highlight bar....
	GOSUB	Invert!
	GOTO	main
**** Set? ********************************************************************
* checks whether the flag given by C.A is set
******************************************************************************
Set?	GOSUB	CntFlags->A
	B=A	W		B.W = flags
	C=C-1	A
* A.A = mask
* B.A = flags
* C.A = loop counter	

	A=0	W
	LA(5)	1		A.1 = 0001 b  (mask)
	C=C-1	B
	GOC	setAandC	initial test
setlp	A=A+A	W		same as ASLB.F  W --> shift the mask left 1 bit
	C=C-1	B		dec. counter
	GONC	setlp
setAandC
	A=A&B	W
	?A=0	W
	GOYES	setend
setend	RTN
**** Toggle ******************************************************************
* Don't have to worry about speed, because the user is pressing the key
******************************************************************************
Toggle
* first fix display
	GOSUB	D->scroll
	GOSUB	Invert!
*  calc the flag number
	GOSUB	D->scroll
	A=R4.F	A
	C=C+A	A
	C=C-1	A
	

	GOSUB	Set?
	GONC	togcl		flag not set
	GOSUB	D->scroll
	GOSUB	SetRow
	GOTO	endshow
togcl	GOSUB	D->scroll
	A=C	A
	GOSUB	showclear
endshow
	GOSUB	D->scroll
	GOSUB	Invert!

** ok, display is updated, now it is time to update the flag

	GOSUB	CntFlags->A
	B=A	W		B.W = flags

	GOSUB	D->scroll
	A=R4.F	A
	C=C+A	A
	C=C-1	B		adjust the value to a bit number

* A.A = mask
* B.A = flags
* C.A = loop counter	
* we now toggle the bit in B.A given in C.B by xor'ing it with a mask

	A=0	W
	C=C-1	B		zero trap
	GOC	togAxorC	
	LA(5)	1		A.1 = 0001 b  (mask)
	C=C-1	B
	GOC	togAxorC	initial test
toglp	A=A+A	W		same as ASLB.F  A --> shift the mask left 1 bit
	C=C-1	B		dec. counter
	GONC	toglp
togAxorC
	C=B	W		put mask in C and call xor
	GOSUB	AxorCW
	GOSUB	A->CntFlags

wait	GOSBVL  =Kbd_OR
	GOC     wait			key still pressed?
	GOTO	main

**** AxorCW ******************************************************************
* Does A.W xor C.W -> A.W
******************************************************************************
AxorCW	B=A	W
	B=B&C	W
	A=A!C	W
	A=A-B	W
	RTN

**** AxorC *******************************************************************
* Does A.A xor C.A -> A.A
******************************************************************************
AxorC	B=A	B
	B=B&C	B
	A=A!C	B
	A=A-B	B
	RTN

**** A->CntFlag **************************************************************
* takes A.W and stores it as the current displayed flags
******************************************************************************
A->CntFlags
	?ST=0	=sUSER
	GOYES	cntflg1
	R3=A
	RTN
cntflg1 R1=A
	RTN

**** CntFlags->A *************************************************************
* returns the current displayed flags to A.W
******************************************************************************
CntFlags->A
	?ST=0	=sUSER
	GOYES	cntflg2
	A=R3
	RTN
cntflg2 A=R1
	RTN

**** A->Row ******************************************************************
* given a row number in A.A, calc write address and puts it into D1
******************************************************************************
A->Row
	A=A-1	A
	LC(5)	34*6
	GOSBVL	=MUL#
	GOSBVL	=D0->Row1	D0 = @ row1 in screen grob
	CD0EX
	C=C+B	A		add offset
	LA(5)	34*2
	C=C+A	A
	CD1EX			D0 is address in ABUFF at beginning of line
	RTN

**** D1->SysFlags ************************************************************
* puts Address of SystemFlags into D1
* trashes C.B
******************************************************************************
D1->SysFlags
        D1=(5)  (addrADISP)+6		base address of ADISP (ie S/SX or G/GX)
        C=DAT1  B
        ?CBIT=1 3
        GOYES   gx
	D1=(5)	=SystemFlags		SX: System flags  
	GOTO	sx
gx	D1=(5)	=SystemFlagsGX		GX: System flags
sx	RTN

**** showclear **************************************************************
* Clears the "tick" mark shown in display 
* A.A = line number
******************************************************************************
showclear
	GOSUB	A->Row
	D1=D1+	3
	C=0	B
	P=	16-6
showclp	
	DAT1=C	B
	D1=D1+	16
	D1=D1+	16
	D1=D1+	2
*	CSR	W
*	CSR	W
	P=P+1
	GONC	showclp
	RTN

**** SetRow ******************************************************************
* Sets the "tick" mark shown in display 
* C.A = line number
******************************************************************************
SetRow
	A=C	A
	GOSUB	A->Row
	D1=D1+	3			12 pixels into line (4 chars)
	P=	0
	LCHEX	000205080000		"tick" data (reversed)
	P=	16-6
setrwlp	DAT1=C	B			write 2 nibs
	D1=D1+	16			\
	D1=D1+	16			 > next line
	D1=D1+	2			/
	CSR	W			ditch those 2 nibs
	CSR	W			
	P=P+1				incr. loop counter
	GONC	setrwlp
	RTN
***** Invert! ****************************************************************
* inverts the screen display row given by C.A ( =row ) from 1 -> 10
******************************************************************************
Invert!
	A=C	A
	GOSUB	A->Row
	P=	16-6		8 rows, so at loop exit, P= 0
writelp	C=DAT1	W		
	C=-C-1	W
	DAT1=C	W		invert 16 nibs
	D1=D1+	16
	C=DAT1	W
	C=-C-1	W
	DAT1=C	W		invert next 16 nibs
	D1=D1+	16
	C=DAT1	B
	C=-C-1	B
	DAT1=C	B		invert last 2 nibs in pixel row
	D1=D1+	2
	P=P+1
	GONC	writelp		at exit, P= 0 --> neat huh?
	RTN

**** ShowNum *****************************************************************
* shows the number next to the description
* C.A is the Flag number
* A.A is line
******************************************************************************
ShowNum
	D=C	A		stash flag number in D
	GOSUB	A->Row
	D1=D1+	1
	C=D	A		get flag num
	A=C	A
	C=0	A
	SETDEC		
	C=C-1	B		setup for loop	
** now we need to convert a hex number into a decimal number (for display)
** this is truly a third rate way of doing it....
swnmlp	SETDEC
	C=C+1	B
	SETHEX	
	A=A-1	B
	GONC	swnmlp		at exit, C.A = 000(tens,single)

	D=C	A
	CSRC	W		put (single) into C.S
	CSR	B		ditch (tens)
	CSLC	W		C.A = 0000(single)

	AD1EX
	B=A	A
	AD1EX
	LA(5)	48		char 0 is number 48
	C=C+A	A		
	GOSUB	Ca->D0		calc bitmap addr
	P=	16-6		initialize P
	GOSUB	doNib		write the single number to display
	C=D	A		get 000(tens,single)
	CSR	B		only tens here
	?C#0	A		are we at flag 1 to 9 ?
	GOYES	swcont
	LC(5)	32-48		then do a space instead (char 32 = space)
swcont
	LA(5)	48		add offset to char 0
	C=C+A	A		
	GOSUB	Ca->D0
	AD1EX
	LC(5)	34*6+1		reset write address & remember, the extra nib
	A=A-C	A
	AD1EX
	P=	16-6		initialize P
	GOSUB	doNib		write char to screen
	RTN

**** D->scroll ***************************************************************
* returns current highlight bar row number to C.A 
******************************************************************************
D->scroll
	C=0	A
	C=D	S
	CSLC	W
	RTN

**** Ca->D0 ******************************************************************
* C.A = char code -> D0 = @ bitmap for that char 
******************************************************************************
Ca->D0	C=C+C   A
	A=C     A
	C=C+C   A
	C=C+A   A		c= 6 * char number
	A=R2 			get address of font
	GOSBVL	=ASRW5	
	A=A+C   A		
	D0=A			D0 = font bitmap for this char
	RTN	

**** BadKey ******************************************************************
* Beeps (like DoBadKey) and waits until no more keys are pressed
******************************************************************************
BadKey	GOSUB	beep		make the beep	
badrec	GOSBVL  =Kbd_OR						<------------
	GOC     badrec		key still pressed?			     |
	RTN								     |
beep	?ST=0	=sBEEP
	GOYES	bpnxt
	RTN	
bpnxt	LC(2)	#FB							     |
	GOVLNG	=RCKBp		jump to address to a routine that does a RTN '

**** keyPressed? *************************************************************
* Checks if a key specified in C.B is down
******************************************************************************
keyPressed?
	A=C     B
	GOVLNG  =ThisKeyDn?		since this is an absolute jump
*					to an address that does a RTN,
*					it will return to the routine that
*					called keyPressed?

**** UpdateTime **************************************************************
* updates the time for delay?
******************************************************************************
UpdateTime
	D1=(5)  =TIMER2
	A=DAT1  A			get current time
	GOSBVL  =ASLW5			A.W = 000000(5 nibs time)00000
	A=R4.F  A			A.W = 000000(5 nibs time)000(top flag)
	R4=A				store new value
	RTN

**** delay? ******************************************************************
* key delay depending on the value of the =sFAST flag
******************************************************************************
delay? ?ST=1   =sFAST			fast mode on?
	RTNYES				then do nothing
	A=R4				get old delay
	GOSBVL  =ASRW5
	LC(5)   8192/10+128		10 ms + a bit
	A=A-C   A			convert to correct amount
	D1=(5)  =TIMER2
delayLp	C=DAT1  A			get time
	?C>A    A			NOT waited enough?
	GOYES   delayLp
	RTN				ok, continue

**** ShowLine ****************************************************************
*
* ENTRY : A.A line to show on
*	: C.A FLAG number
*
******************************************************************************
ShowLine
	C=C-1	A
	D=C	A		shove flag number on D.A
	
* Now calculate screen write address
	A=A-1	A
	LC(5)	34*6
	GOSBVL	=MUL#
	GOSBVL	=D0->Row1
	CD0EX
	C=C+B	A
	LA(5)	34*2+5		offset 2 lines down and 5*4 pixels in
	C=C+A	A	
	D1=C			D1 = write address

	?ST=0	=sUSER
	GOYES	showCont
	B=C	A		initialize write addr
	GOSUB	user$
	NIBASC	/User Flag/
user$	C=RSTK	
	R0=C
	LC(5)	9		length of string
	RSTK=C	A
	GOTO	ShowUser
showCont

** Compute the address of appropriate bit battern.
	C=D	A		get flag number
	C=C+C	A		x 2
	C=C+C	A		x 4
	A=R2.F	A		begin of offset table
	C=C+A	A		get flag data address
	D0=C
	C=0	A
	P=	3
	C=DAT0	WP		C[A]: 00(offset)
	P=	0	
	AD0EX
	C=C+A	A
	CD0EX			D0 = address of 2 nib length
	C=0	A
	C=DAT0	B
	D0=D0+	2		D0 is address of string data
	AD0EX
	R0=A.F	A		string data address initialized

	AD1EX			retrieve screen write address
	B=A	A		write address initialized
	RSTK=C			number of chars initialized

* Setup number of chars to write
ShowUser
	LC(5)   32-5
	D=C     A		D.A = loop counter (32 chars max width)
**** WriteLp *****************************************************************
* AUTHOR: Dan Kirkland (modified)
* INFO	: Writes the string data into the display
* ENTRY	: 
*	: A.A 
*	: B.A = write! address
*	: C.A 
*	: D.A = total number of chars -> #20h or #32d
*
*	: RSTK= string length
*	: R0  = string data address
*
******************************************************************************
WriteLp	C=RSTK						<-------
	C=C-1   A		C.A = string len		|
	GOC     nochars		no more chars...		|
	RSTK=C			store string len back..		|
	C=R0.F  A						|
	D1=C			String data address		|
	C=C+CON A,2						|
	R0=C.F  A		store back..			|
	C=0     A						|
	C=DAT1  B		get 2 nibs char data		|
	GOSUB   Write		write loop			|
	D=D-1   B		dec loop counter		|
	GONC    WriteLp		finished? no, then do again ----
	C=RSTK			pop string len
	C=C-1   A		
	GOC     exitwr		no more chars, so exit
	B=B-1   A
	LC(5)   #1F		more chars, so do elipsis
	GOSUB   Write		write loop
	GONC    exitwr		exit?
nochars	C=0     A		more to do still
WrtBlank 
	LC(3)   #20		space.
	GOSUB	Write		write
	D=D-1	B		sub width still to do.
	GONC    WrtBlank		fill the rest of the line
exitwr	RTN			RETURN TO CALLER
Write	A=B     A
	D1=A			d1 = write!
	GOSUB	Ca->D0
	P=      16-6		6 rows
doNib	C=DAT0  S		read
	DAT1=C  S		write!
	D0=D0+  1		next data bit
	D1=D1+  16		\
	D1=D1+  16		 > next row
	D1=D1+  2		/
	P=P+1			
	GONC    doNib
	B=B+1   A		incr write address
	RTN
******************************************************************************
* Table of offsets and strings
******************************************************************************
GetTab	GOSUBL	EndOffsetTable
	REL(4)	f1
	REL(4)	f2
	REL(4)	f3
	REL(4)	f4			* Not Used
	REL(4)	f5
	REL(4)	f6
	REL(4)	f7
	REL(4)	f8
	REL(4)	f9
	REL(4)	f10
	REL(4)	f11
	REL(4)	f12
	REL(4)	f4			* flag 13
	REL(4)	f14			
	REL(4)	f15
	REL(4)	f16
	REL(4)	f17
	REL(4)	f18
	REL(4)	f19
	REL(4)	f20
	REL(4)	f21
	REL(4)	f22
	REL(4)	f23
	REL(4)	f24
	REL(4)	f25
	REL(4)	f26
	REL(4)	f27			* flag 27
	REL(4)	f28			* flag 28
	REL(4)	f29			* flag 29
	REL(4)	f30
	REL(4)	f31
	REL(4)	f32
	REL(4)	f33
	REL(4)	f34
	REL(4)	f35
	REL(4)	f36
	REL(4)	f37
	REL(4)	f38
	REL(4)	f39
	REL(4)	f40
	REL(4)	f41
	REL(4)	f42
	REL(4)	f43
	REL(4)	f44
	REL(4)	f45
	REL(4)	f46
	REL(4)	f47
	REL(4)	f48
	REL(4)	f49
	REL(4)	f50
	REL(4)	f51
	REL(4)	f52
	REL(4)	f53
	REL(4)	f54			* flag 54
	REL(4)	f55
	REL(4)	f56
	REL(4)	f57
	REL(4)	f58
	REL(4)	f59
	REL(4)	f60
	REL(4)	f61
	REL(4)	f62
	REL(4)	f63
	REL(4)	f64

*****************************************************************************
f1	NIBHEX	21			* 18d wide
	NIBASC	/Principal Solution/
f2	NIBHEX	21
	NIBASC	/Symbolic Constants/
f3	NIBHEX	11
	NIBASC	/Numerical Results/
f4	NIBHEX	80
	NIBASC	/Not Used/
f5	NIBHEX	A0
	NIBASC	/Wordsize 1/
f6	NIBHEX	A0
	NIBASC	/Wordsize 2/
f7	NIBHEX	A0
	NIBASC	/Wordsize 4/
f8	NIBHEX	A0
	NIBASC	/Wordsize 8/
f9	NIBHEX	B0
	NIBASC	/Wordsize 16/
f10	NIBHEX	B0
	NIBASC	/Wordsize 32/
f11	NIBHEX	A0
	NIBASC	/BIN or HEX/
f12	NIBHEX	A0
	NIBASC	/OCT or HEX/
f14	NIBHEX	C1
	NIBASC	/TVM uses begin pay mode  (G)/			* G only
f15	NIBHEX	50
	NIBASC	/Polar/
f16	NIBHEX	90
	NIBASC	/Spherical/
f17	NIBHEX	70
	NIBASC	/Radians/
f18	NIBHEX	50
	NIBASC	/Grads/
f19	NIBHEX	A0
	NIBASC	/2D Complex/
f20	NIBHEX	91
	NIBASC	/Underflow Exception Error/
f21	NIBHEX	81
	NIBASC	/Overflow Exception Error/
f22	NIBHEX	A1
	NIBASC	/Infinite Result: +/
	NIBHEX	F2
	NIBASC	/- 1E500/
f23	NIBHEX	81
	NIBASC	/Neg. Underflow Indicator/
f24	NIBHEX	81
	NIBASC	/Pos. Underflow Indicator/
f25	NIBHEX	21
	NIBASC	/Overflow Indicator/
f26	NIBHEX	91
	NIBASC	/Infinite Result Indicator/
f27	NIBHEX	C1
	NIBASC	/Display complex using i  (G)/
f28	NIBHEX	C1
	NIBASC	/Plot multi. eqns simult. (G)/
f29	NIBHEX	C1
	NIBASC	/Don't show axes 2D,stat  (G)/
f30	NIBHEX	C1
	NIBASC	/Separate y, f(x) plots   (S)/
f31	NIBHEX	11
	NIBASC	/Curve Filling Off/
f32	NIBHEX	31
	NIBASC	/XOR Graphics Cursor/
f33	NIBHEX	E0
	NIBASC	/I/
	NIBHEX	F2
	NIBASC	/O to IR Port/
f34	NIBHEX	41
	NIBASC	/Print to Serial Port/
f35	NIBHEX	A0
	NIBASC	/Binary I/
	NIBHEX	F2
	NIBASC	/O/
f36	NIBHEX	E0
	NIBASC	/RECV Overwrite/
f37	NIBHEX	61
	NIBASC	/Double-Spaced Printing/
f38	NIBHEX	D0
	NIBASC	/Auto Linefeed/
f39	NIBHEX	01
	NIBASC	/I/
	NIBHEX	F2
	NIBASC	/O Messages Off/
f40	NIBHEX	D0
	NIBASC	/Clock Display/
f41	NIBHEX	D0
	NIBASC	/24 Hour Clock/
f42	NIBHEX	41
	NIBASC	/European Date Format/
f43	NIBHEX	A1
	NIBASC	/Rpt Alarms Not Rescheduled/
f44	NIBHEX	91
	NIBASC	/Acknowledged Alarms Saved/
f45	NIBHEX	21
	NIBASC	/Display Rounding 1/
f46	NIBHEX	21
	NIBASC	/Display Rounding 2/
f47	NIBHEX	21
	NIBASC	/Display Rounding 4/
f48	NIBHEX	21
	NIBASC	/Display Rounding 8/
f49	NIBHEX	A0
	NIBASC	/FIX or ENG/
f50	NIBHEX	A0
	NIBASC	/SCI or ENG/
f51	NIBHEX	31
	NIBASC	/Fraction Mark Comma/
f52	NIBHEX	31
	NIBASC	/Single-Line Display/
f53	NIBHEX	41
	NIBASC	/Show All Parentheses/
f54	NIBHEX	C1
	NIBASC	/Disable Auto Matrix RND  (G)/		** GX only
f55	NIBHEX	81
	NIBASC	/Last Arguments Not Saved/
f56	NIBHEX	71
	NIBASC	/BEEP AND Error Beep Off/
f57	NIBHEX	E0
	NIBASC	/Alarm Beep Off/
f58	NIBHEX	41
	NIBASC	/Verbose MESSAGES Off/
f59	NIBHEX	41
	NIBASC	/Fast Catalog Display/
f60	NIBHEX	A0
	NIBASC	/Alpha Lock/
f61	NIBHEX	E0
	NIBASC	/User Mode Lock/
f62	NIBHEX	01
	NIBASC	/User Mode Active/
f63	NIBHEX	E0
	NIBASC	/Vectored ENTER/
f64	NIBHEX	41
	NIBASC	/Index Wrap Indicator/
******************************************************************************
EndOffsetTable
	C=RSTK			put address of font offset table into C.A
	RTN
ENDCODE
;
